<?php

namespace Lib\OmnivaService;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CostReportExportRequestType' => '\\Lib\\OmnivaService\\StructType\\CostReportExportRequestType',
            'CostReportExportResponseType' => '\\Lib\\OmnivaService\\StructType\\CostReportExportResponseType',
            'CostReportAttachmentRequestType' => '\\Lib\\OmnivaService\\StructType\\CostReportAttachmentRequestType',
            'CostReportAttachmentResponseType' => '\\Lib\\OmnivaService\\StructType\\CostReportAttachmentResponseType',
            'CostReportAttachmentType' => '\\Lib\\OmnivaService\\StructType\\CostReportAttachmentType',
            'EInvoiceResponseType' => '\\Lib\\OmnivaService\\StructType\\EInvoiceResponseType',
            'EInvoiceRespoonseType' => '\\Lib\\OmnivaService\\StructType\\EInvoiceRespoonseType',
            'BuyInvoicePdfRequest' => '\\Lib\\OmnivaService\\StructType\\BuyInvoicePdfRequest',
            'BuyInvoicePdfResponse' => '\\Lib\\OmnivaService\\StructType\\BuyInvoicePdfResponse',
            'SaleInvoiceBuyStatusRequestType' => '\\Lib\\OmnivaService\\StructType\\SaleInvoiceBuyStatusRequestType',
            'SaleInvoiceBuyStatusResponseType' => '\\Lib\\OmnivaService\\StructType\\SaleInvoiceBuyStatusResponseType',
            'SaleInvoiceBuyStatusType' => '\\Lib\\OmnivaService\\StructType\\SaleInvoiceBuyStatusType',
            'BuyInvoiceReqType' => '\\Lib\\OmnivaService\\StructType\\BuyInvoiceReqType',
            'BuyInvoiceRegisteredReqType' => '\\Lib\\OmnivaService\\StructType\\BuyInvoiceRegisteredReqType',
            'RegisteredInvoiceType' => '\\Lib\\OmnivaService\\StructType\\RegisteredInvoiceType',
            'SaleInvoiceExportReqType' => '\\Lib\\OmnivaService\\StructType\\SaleInvoiceExportReqType',
            'EInvoiceRequest' => '\\Lib\\OmnivaService\\StructType\\EInvoiceRequest',
            'SimpleResponseType' => '\\Lib\\OmnivaService\\StructType\\SimpleResponseType',
            'Base64FileType' => '\\Lib\\OmnivaService\\StructType\\Base64FileType',
            'InvoiceAttachmentType' => '\\Lib\\OmnivaService\\StructType\\InvoiceAttachmentType',
            'AccountPlanRequestType' => '\\Lib\\OmnivaService\\StructType\\AccountPlanRequestType',
            'ClientRegistryRequestType' => '\\Lib\\OmnivaService\\StructType\\ClientRegistryRequestType',
            'DimensionRegistryResponse' => '\\Lib\\OmnivaService\\StructType\\DimensionRegistryResponse',
            'DimensionRegistryConnectionErrorsType' => '\\Lib\\OmnivaService\\StructType\\DimensionRegistryConnectionErrorsType',
            'ImportError' => '\\Lib\\OmnivaService\\StructType\\ImportError',
            'DimensionRegistryConnectionPartType' => '\\Lib\\OmnivaService\\StructType\\DimensionRegistryConnectionPartType',
            'DimensionRegistryRequestType' => '\\Lib\\OmnivaService\\StructType\\DimensionRegistryRequestType',
            'InvoiceAttachmentRequestType' => '\\Lib\\OmnivaService\\StructType\\InvoiceAttachmentRequestType',
            'InvoiceAttachmentResponseType' => '\\Lib\\OmnivaService\\StructType\\InvoiceAttachmentResponseType',
            'CompanyStatusRequestType' => '\\Lib\\OmnivaService\\StructType\\CompanyStatusRequestType',
            'RegNumber' => '\\Lib\\OmnivaService\\StructType\\RegNumber',
            'CompanyStatusResponseType' => '\\Lib\\OmnivaService\\StructType\\CompanyStatusResponseType',
            'CompanyActiveType' => '\\Lib\\OmnivaService\\StructType\\CompanyActiveType',
            'RejectConfirmationRequestType' => '\\Lib\\OmnivaService\\StructType\\RejectConfirmationRequestType',
            'RejectContentType' => '\\Lib\\OmnivaService\\StructType\\RejectContentType',
            'RegistryImportRequest' => '\\Lib\\OmnivaService\\StructType\\RegistryImportRequest',
            'RegistryImportResponse' => '\\Lib\\OmnivaService\\StructType\\RegistryImportResponse',
            'AuthenticatedRequest' => '\\Lib\\OmnivaService\\StructType\\AuthenticatedRequest',
            'E_Invoice' => '\\Lib\\OmnivaService\\StructType\\E_Invoice',
            'Header' => '\\Lib\\OmnivaService\\StructType\\Header',
            'Invoice' => '\\Lib\\OmnivaService\\StructType\\Invoice',
            'InvoiceParties' => '\\Lib\\OmnivaService\\StructType\\InvoiceParties',
            'InvoiceInformation' => '\\Lib\\OmnivaService\\StructType\\InvoiceInformation',
            'Type' => '\\Lib\\OmnivaService\\StructType\\Type',
            'Period' => '\\Lib\\OmnivaService\\StructType\\Period',
            'InvoiceSumGroup' => '\\Lib\\OmnivaService\\StructType\\InvoiceSumGroup',
            'Balance' => '\\Lib\\OmnivaService\\StructType\\Balance',
            'InvoiceItem' => '\\Lib\\OmnivaService\\StructType\\InvoiceItem',
            'InvoiceItemGroup' => '\\Lib\\OmnivaService\\StructType\\InvoiceItemGroup',
            'ItemEntry' => '\\Lib\\OmnivaService\\StructType\\ItemEntry',
            'GroupEntry' => '\\Lib\\OmnivaService\\StructType\\GroupEntry',
            'PaymentInfo' => '\\Lib\\OmnivaService\\StructType\\PaymentInfo',
            'AccountDataRecord' => '\\Lib\\OmnivaService\\StructType\\AccountDataRecord',
            'AccountingRecord' => '\\Lib\\OmnivaService\\StructType\\AccountingRecord',
            'JournalEntry' => '\\Lib\\OmnivaService\\StructType\\JournalEntry',
            'AdditionRecord' => '\\Lib\\OmnivaService\\StructType\\AdditionRecord',
            'AddressRecord' => '\\Lib\\OmnivaService\\StructType\\AddressRecord',
            'BillPartyRecord' => '\\Lib\\OmnivaService\\StructType\\BillPartyRecord',
            'ContactDataRecord' => '\\Lib\\OmnivaService\\StructType\\ContactDataRecord',
            'ExtensionRecord' => '\\Lib\\OmnivaService\\StructType\\ExtensionRecord',
            'VATRecord' => '\\Lib\\OmnivaService\\StructType\\VATRecord',
        );
    }
}
