<?php

namespace Lib\OmnivaService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CompanyActiveType StructType
 * @subpackage Structs
 */
class CompanyActiveType extends \Lib\OmnivaService\EnumType\YesNoType
{
    /**
     * The regNumber
     * Meta informations extracted from the WSDL
     * - use: required
     * - maxLength: 15
     * @var string
     */
    public $regNumber;
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The country
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $country;
    /**
     * Constructor method for CompanyActiveType
     * @uses CompanyActiveType::setRegNumber()
     * @uses CompanyActiveType::set_()
     * @uses CompanyActiveType::setCountry()
     * @param string $regNumber
     * @param string $_
     * @param string $country
     */
    public function __construct($regNumber = null, $_ = null, $country = null)
    {
        $this
            ->setRegNumber($regNumber)
            ->set_($_)
            ->setCountry($country);
    }
    /**
     * Get regNumber value
     * @return string
     */
    public function getRegNumber()
    {
        return $this->regNumber;
    }
    /**
     * Set regNumber value
     * @param string $regNumber
     * @return \Lib\OmnivaService\StructType\CompanyActiveType
     */
    public function setRegNumber($regNumber = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($regNumber) && strlen($regNumber) > 15) || (is_array($regNumber) && count($regNumber) > 15)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 15 element(s) or a scalar of 15 character(s) at most, "%d" length given', is_scalar($regNumber) ? strlen($regNumber) : count($regNumber)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($regNumber) && !is_string($regNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($regNumber)), __LINE__);
        }
        $this->regNumber = $regNumber;
        return $this;
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @uses \Lib\OmnivaService\EnumType\YesNoType::valueIsValid()
     * @uses \Lib\OmnivaService\EnumType\YesNoType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $_
     * @return \Lib\OmnivaService\StructType\CompanyActiveType
     */
    public function set_($_ = null)
    {
        // validation for constraint: enumeration
        if (!\Lib\OmnivaService\EnumType\YesNoType::valueIsValid($_)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $_, implode(', ', \Lib\OmnivaService\EnumType\YesNoType::getValidValues())), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \Lib\OmnivaService\StructType\CompanyActiveType
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Lib\OmnivaService\StructType\CompanyActiveType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
