<?php

namespace Lib\OmnivaService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvoiceAttachmentResponseType StructType
 * @subpackage Structs
 */
class InvoiceAttachmentResponseType extends AbstractStructBase
{
    /**
     * The nextAttachmentIndex
     * Meta informations extracted from the WSDL
     * - use: required
     * @var int
     */
    public $nextAttachmentIndex;
    /**
     * The InvoiceAttachment
     * Meta informations extracted from the WSDL
     * - documentation: Element representing single attachment
     * @var \Lib\OmnivaService\StructType\InvoiceAttachmentType
     */
    public $InvoiceAttachment;
    /**
     * Constructor method for InvoiceAttachmentResponseType
     * @uses InvoiceAttachmentResponseType::setNextAttachmentIndex()
     * @uses InvoiceAttachmentResponseType::setInvoiceAttachment()
     * @param int $nextAttachmentIndex
     * @param \Lib\OmnivaService\StructType\InvoiceAttachmentType $invoiceAttachment
     */
    public function __construct($nextAttachmentIndex = null, \Lib\OmnivaService\StructType\InvoiceAttachmentType $invoiceAttachment = null)
    {
        $this
            ->setNextAttachmentIndex($nextAttachmentIndex)
            ->setInvoiceAttachment($invoiceAttachment);
    }
    /**
     * Get nextAttachmentIndex value
     * @return int
     */
    public function getNextAttachmentIndex()
    {
        return $this->nextAttachmentIndex;
    }
    /**
     * Set nextAttachmentIndex value
     * @param int $nextAttachmentIndex
     * @return \Lib\OmnivaService\StructType\InvoiceAttachmentResponseType
     */
    public function setNextAttachmentIndex($nextAttachmentIndex = null)
    {
        // validation for constraint: int
        if (!is_null($nextAttachmentIndex) && !is_numeric($nextAttachmentIndex)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($nextAttachmentIndex)), __LINE__);
        }
        $this->nextAttachmentIndex = $nextAttachmentIndex;
        return $this;
    }
    /**
     * Get InvoiceAttachment value
     * @return \Lib\OmnivaService\StructType\InvoiceAttachmentType|null
     */
    public function getInvoiceAttachment()
    {
        return $this->InvoiceAttachment;
    }
    /**
     * Set InvoiceAttachment value
     * @param \Lib\OmnivaService\StructType\InvoiceAttachmentType $invoiceAttachment
     * @return \Lib\OmnivaService\StructType\InvoiceAttachmentResponseType
     */
    public function setInvoiceAttachment(\Lib\OmnivaService\StructType\InvoiceAttachmentType $invoiceAttachment = null)
    {
        $this->InvoiceAttachment = $invoiceAttachment;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Lib\OmnivaService\StructType\InvoiceAttachmentResponseType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
