<?php

namespace Lib\OmnivaService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvoiceItem StructType
 * @subpackage Structs
 */
class InvoiceItem extends AbstractStructBase
{
    /**
     * The InvoiceItemGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - ref: InvoiceItemGroup
     * @var \Lib\OmnivaService\StructType\InvoiceItemGroup[]
     */
    public $InvoiceItemGroup;
    /**
     * Constructor method for InvoiceItem
     * @uses InvoiceItem::setInvoiceItemGroup()
     * @param \Lib\OmnivaService\StructType\InvoiceItemGroup[] $invoiceItemGroup
     */
    public function __construct(array $invoiceItemGroup = array())
    {
        $this
            ->setInvoiceItemGroup($invoiceItemGroup);
    }
    /**
     * Get InvoiceItemGroup value
     * @return \Lib\OmnivaService\StructType\InvoiceItemGroup[]|null
     */
    public function getInvoiceItemGroup()
    {
        return $this->InvoiceItemGroup;
    }
    /**
     * Set InvoiceItemGroup value
     * @throws \InvalidArgumentException
     * @param \Lib\OmnivaService\StructType\InvoiceItemGroup[] $invoiceItemGroup
     * @return \Lib\OmnivaService\StructType\InvoiceItem
     */
    public function setInvoiceItemGroup(array $invoiceItemGroup = array())
    {
        foreach ($invoiceItemGroup as $invoiceItemInvoiceItemGroupItem) {
            // validation for constraint: itemType
            if (!$invoiceItemInvoiceItemGroupItem instanceof \Lib\OmnivaService\StructType\InvoiceItemGroup) {
                throw new \InvalidArgumentException(sprintf('The InvoiceItemGroup property can only contain items of \Lib\OmnivaService\StructType\InvoiceItemGroup, "%s" given', is_object($invoiceItemInvoiceItemGroupItem) ? get_class($invoiceItemInvoiceItemGroupItem) : gettype($invoiceItemInvoiceItemGroupItem)), __LINE__);
            }
        }
        $this->InvoiceItemGroup = $invoiceItemGroup;
        return $this;
    }
    /**
     * Add item to InvoiceItemGroup value
     * @throws \InvalidArgumentException
     * @param \Lib\OmnivaService\StructType\InvoiceItemGroup $item
     * @return \Lib\OmnivaService\StructType\InvoiceItem
     */
    public function addToInvoiceItemGroup(\Lib\OmnivaService\StructType\InvoiceItemGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Lib\OmnivaService\StructType\InvoiceItemGroup) {
            throw new \InvalidArgumentException(sprintf('The InvoiceItemGroup property can only contain items of \Lib\OmnivaService\StructType\InvoiceItemGroup, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InvoiceItemGroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Lib\OmnivaService\StructType\InvoiceItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
