<?php

namespace Lib\OmnivaService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvoiceParties StructType
 * @subpackage Structs
 */
class InvoiceParties extends AbstractStructBase
{
    /**
     * The SellerParty
     * @var \Lib\OmnivaService\StructType\BillPartyRecord
     */
    public $SellerParty;
    /**
     * The BuyerParty
     * @var \Lib\OmnivaService\StructType\BillPartyRecord
     */
    public $BuyerParty;
    /**
     * The RecipientParty
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Lib\OmnivaService\StructType\BillPartyRecord
     */
    public $RecipientParty;
    /**
     * The DeliveryParty
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Lib\OmnivaService\StructType\BillPartyRecord
     */
    public $DeliveryParty;
    /**
     * Constructor method for InvoiceParties
     * @uses InvoiceParties::setSellerParty()
     * @uses InvoiceParties::setBuyerParty()
     * @uses InvoiceParties::setRecipientParty()
     * @uses InvoiceParties::setDeliveryParty()
     * @param \Lib\OmnivaService\StructType\BillPartyRecord $sellerParty
     * @param \Lib\OmnivaService\StructType\BillPartyRecord $buyerParty
     * @param \Lib\OmnivaService\StructType\BillPartyRecord $recipientParty
     * @param \Lib\OmnivaService\StructType\BillPartyRecord $deliveryParty
     */
    public function __construct(\Lib\OmnivaService\StructType\BillPartyRecord $sellerParty = null, \Lib\OmnivaService\StructType\BillPartyRecord $buyerParty = null, \Lib\OmnivaService\StructType\BillPartyRecord $recipientParty = null, \Lib\OmnivaService\StructType\BillPartyRecord $deliveryParty = null)
    {
        $this
            ->setSellerParty($sellerParty)
            ->setBuyerParty($buyerParty)
            ->setRecipientParty($recipientParty)
            ->setDeliveryParty($deliveryParty);
    }
    /**
     * Get SellerParty value
     * @return \Lib\OmnivaService\StructType\BillPartyRecord|null
     */
    public function getSellerParty()
    {
        return $this->SellerParty;
    }
    /**
     * Set SellerParty value
     * @param \Lib\OmnivaService\StructType\BillPartyRecord $sellerParty
     * @return \Lib\OmnivaService\StructType\InvoiceParties
     */
    public function setSellerParty(\Lib\OmnivaService\StructType\BillPartyRecord $sellerParty = null)
    {
        $this->SellerParty = $sellerParty;
        return $this;
    }
    /**
     * Get BuyerParty value
     * @return \Lib\OmnivaService\StructType\BillPartyRecord|null
     */
    public function getBuyerParty()
    {
        return $this->BuyerParty;
    }
    /**
     * Set BuyerParty value
     * @param \Lib\OmnivaService\StructType\BillPartyRecord $buyerParty
     * @return \Lib\OmnivaService\StructType\InvoiceParties
     */
    public function setBuyerParty(\Lib\OmnivaService\StructType\BillPartyRecord $buyerParty = null)
    {
        $this->BuyerParty = $buyerParty;
        return $this;
    }
    /**
     * Get RecipientParty value
     * @return \Lib\OmnivaService\StructType\BillPartyRecord|null
     */
    public function getRecipientParty()
    {
        return $this->RecipientParty;
    }
    /**
     * Set RecipientParty value
     * @param \Lib\OmnivaService\StructType\BillPartyRecord $recipientParty
     * @return \Lib\OmnivaService\StructType\InvoiceParties
     */
    public function setRecipientParty(\Lib\OmnivaService\StructType\BillPartyRecord $recipientParty = null)
    {
        $this->RecipientParty = $recipientParty;
        return $this;
    }
    /**
     * Get DeliveryParty value
     * @return \Lib\OmnivaService\StructType\BillPartyRecord|null
     */
    public function getDeliveryParty()
    {
        return $this->DeliveryParty;
    }
    /**
     * Set DeliveryParty value
     * @param \Lib\OmnivaService\StructType\BillPartyRecord $deliveryParty
     * @return \Lib\OmnivaService\StructType\InvoiceParties
     */
    public function setDeliveryParty(\Lib\OmnivaService\StructType\BillPartyRecord $deliveryParty = null)
    {
        $this->DeliveryParty = $deliveryParty;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Lib\OmnivaService\StructType\InvoiceParties
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
